#include "Device/Beam/Beam.h"
#include "Base/Math/Constants.h"
#include "Device/Beam/FootprintGauss.h"
#include "Device/Beam/FootprintSquare.h"
#include "Tests/GTestWrapper/google_test.h"

#include <memory>

class BeamTest : public ::testing::Test {
};

TEST_F(BeamTest, BeamPolarization)
{
    Beam beam = Beam::horizontalBeam();
    kvector_t polarization(0.1, -0.2, 0.4);
    beam.setPolarization(polarization);

    kvector_t bloch_vector = beam.getBlochVector();
    EXPECT_NEAR(0.1, bloch_vector.x(), 1e-8);
    EXPECT_NEAR(-0.2, bloch_vector.y(), 1e-8);
    EXPECT_NEAR(0.4, bloch_vector.z(), 1e-8);
}
